src/Entity/Employe.php
<?php

namespace App\Entity;

use App\Repository\EmployeRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: EmployeRepository::class)]
class Employe
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 50)]
    private ?string $nom = null;

    #[ORM\Column(length: 50)]
    private ?string $prenom = null;

    #[ORM\Column(type: Types::DATETIME_MUTABLE, nullable: true)]
    private ?\DateTimeInterface $dateNaissance = null;

    #[ORM\Column(type: Types::DATETIME_MUTABLE)]
    private ?\DateTimeInterface $dateEmbauche = null;

    #[ORM\ManyToOne(inversedBy: 'employes')]
    #[ORM\JoinColumn(nullable: false)]
    private ?Entreprise $entreprise = null;

    #[ORM\Column(length: 50)]
    private ?string $ville = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getNom(): ?string
    {
        return $this->nom;
    }

    public function setNom(string $nom): static
    {
        $this->nom = $nom;

        return $this;
    }

    public function getPrenom(): ?string
    {
        return $this->prenom;
    }

    public function setPrenom(string $prenom): static
    {
        $this->prenom = $prenom;

        return $this;
    }

    public function getDateNaissance(): ?\DateTimeInterface
    {
        return $this->dateNaissance;
    }

    public function setDateNaissance(?\DateTimeInterface $dateNaissance): static
    {
        $this->dateNaissance = $dateNaissance;

        return $this;
    }

    public function getDateEmbauche(): ?\DateTimeInterface
    {
        return $this->dateEmbauche;
    }

    public function setDateEmbauche(\DateTimeInterface $dateEmbauche): static
    {
        $this->dateEmbauche = $dateEmbauche;

        return $this;
    }

    public function getEntreprise(): ?Entreprise
    {
        return $this->entreprise;
    }

    public function setEntreprise(?Entreprise $entreprise): static
    {
        $this->entreprise = $entreprise;

        return $this;
    }

    public function __toString()
    {
        return $this->getPrenom() . ' ' . $this->getNom();
    }

    public function getVille(): ?string
    {
        return $this->ville;
    }

    public function setVille(string $ville): static
    {
        $this->ville = $ville;

        return $this;
    }

    public function getAge(): ?string
    {
        $now = new \DateTime();
        $interval = $this->dateNaissance->diff($now);
        return $interval->format('%y ans');
    }
}

src/Form/EmployeType.php
<?php

namespace App\Form;

use App\Entity\Employe;
use App\Entity\Entreprise;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;

class EmployeType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('nom', TextType::class, 
            [
                'attr' => [
                    'class' => 'form-control'
                ]
            ])
            ->add('prenom', TextType::class, 
            [
                'attr' => [
                    'class' => 'form-control'
                ]
            ])
            ->add('dateNaissance', DateType::class, 
            [
                'widget' => 'single_text',
                'attr' => [
                    'class' => 'form-control'
                ]
            ])
            ->add('dateEmbauche', DateType::class, 
            [   
                'widget' => 'single_text',
                'attr' => [
                    'class' => 'form-control'
                ]
            ])
            ->add('ville', TextType::class, 
            [
                'required' => false,
                'attr' => [
                    'class' => 'form-control'
                ]
            ])
            ->add('entreprise', EntityType::class 
            , [
                'class' => Entreprise::class,
                'attr' => [
                    'class' => 'form-control'
                ]
            ])
            ->add('valider', SubmitType::class,
            [
                'attr' => [
                    'class' => 'btn btn-success'
                ]
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Employe::class,
        ]);
    }
}

src/Controller/EmployeController.php
<?php

namespace App\Controller;

use App\Entity\Employe;
use App\Form\EmployeType;
use App\Repository\EmployeRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;

class EmployeController extends AbstractController
{
    #[Route('/employe', name: 'app_employe')]
    public function index(EmployeRepository $employeRepository): Response
    {
        //$employes = $employeRepository->findAll();
        $employes = $employeRepository->findBy([],["prenom" => "ASC"]);
        return $this->render('employe/index.html.twig', [
            'employes' => $employes
        ]);
    }
    #[Route('/employe/new', name: 'new_employe')]
    #[Route('/employe/{id}/edit', name: 'edit_employe')]
    public function new(Employe $employe = null, Request $request, EntityManagerInterface $entityManager): Response
    {
        if (!$employe) {
        $employe = new Employe();
        }

        $form = $this->createForm(EmployeType::class, $employe);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            // $form->getData() holds the submitted values
            // but, the original `$task` variable has also been updated
            $employe = $form->getData();
            // tell Doctrine you want to (eventually) save the Product (no queries yet)
            $entityManager->persist($employe);

            // actually executes the queries (i.e. the INSERT query)
            $entityManager->flush();

            // ... perform some action, such as saving the task to the database
            return $this->redirectToRoute('app_employe');
        }

        return $this->render('employe/new.html.twig', [
            'formAddEmploye' => $form,
            'edit' => $employe->getId()
        ]);
    }

    #[Route('/employe/{id}/delete', name: 'delete_employe')]
    public function delete(Employe $employe, EntityManagerInterface $entityManager): Response
    {
        $entityManager->remove($employe);
        $entityManager->flush();
        return $this->redirectToRoute('app_employe');
    }

    #[Route('/employe/{id}', name: 'show_employe')]
    public function show(Employe $employe): Response
    {
        return $this->render('employe/show.html.twig', [
            'employe' => $employe
        ]);
    }
}

templates/employe/index.html.twig
    {% extends 'base.html.twig' %}

    {% block title %}Hello EmployeController!{% endblock %}

    {% block body %}
        <h1> Liste des Emplyoyes </h1>
        <a class="btn btn-success"  href="{{path('new_employe')}}">Ajouter un employe</a> <br>
        {% for employe in employes %}
            <a href ="{{path('show_employe', {'id': employe.id})}}">{{ employe }}</a> {{employe.entreprise.raisonSocial}}
            <a class="btn btn-warning" href ="{{path('edit_employe', {'id': employe.id})}} ">Edit</a>
            <a class="btn btn-danger" href ="{{path('delete_employe', {'id': employe.id})}} ">Delete</a>

            </br>
        {% endfor %}
    {% endblock %}

templates/employe/new.html.twig
  {% extends 'base.html.twig' %}

    {% block title %}Liste des Employe{% endblock %}

    {% block body %}
        {% if edit %}
            <h1>editer un employe</h1>
        {% else %}
            <h1>Ajouter un employe</h1>
        {% endif %}
       {#  {{ form(formAddEmploye) }} #}
        {{ form_start(formAddEmploye) }}
            <div class="row">
                <div class="col-sm">
                    {{ form_row(formAddEmploye.nom) }}
                </div>
                <div class="col-sm">
                    {{ form_row(formAddEmploye.prenom) }}
                </div>
            </div>
            <div class="row">
                <div class="col-sm">
                    {{ form_row(formAddEmploye.dateNaissance) }}
                </div>
                <div class="col-sm">
                    {{ form_row(formAddEmploye.dateEmbauche) }}
                </div>
            </div>
            {{ form_row(formAddEmploye.entreprise) }}
            {{ form_row(formAddEmploye.ville) }}
            {{ form_row(formAddEmploye.valider) }}
        {{ form_end(formAddEmploye) }}

    {% endblock %}

templates/employe/show.html.twig
    {% extends 'base.html.twig' %}

    {% block title %}Liste des Entreprises{% endblock %}

    {% block body %}
        <h1>Détails d'un Employé</h1>
        <h2>{{ employe }}</h2>
        <p>
            Entreprise : <a href="{{path('show_entreprise', {'id': employe.entreprise.id})}}"> {{ employe.entreprise }}</a> <br>
            La ville : {% if employe.ville %} {{ employe.ville }} {% else %} ville non renseignées {% endif %} <br>
            Date de naisance : {{ employe.dateNaissance | date("d.m.Y") }}</br>
            Age = {{ employe.age}} </br>
            Date d'embauche : {{ employe.dateEmbauche | date("d.m.Y") }} 
        </p>
            
    {% endblock %}